View Issue Details

IDProjectCategoryView StatusLast Update
0002563SymmetricDSBugpublic2019-06-25 14:06
ReporterMikaNAssigned Tojosh-a-hicks 
Priorityurgent 
Status closedResolutionfixed 
Product Version3.7.32 
Target VersionFixed in Version3.10.3 
Summary0002563: When Primary key is binary; SymmetricDS fails capture changes.
DescriptionShould we reopen bug 0002219 ? It was marked as "fixed" but I'm getting the same error even with the latest Symmetric version.

When primary key type is varbinary Symmetrics fails with following error:

[replonv2] - AcknowledgeService - The outgoing batch 001-13 failed. There are no keys defined for Reporting-DB.dbo.booking_offers. Cannot build an update statement. The only keys defined are binary and they have been removed.
[replonv2] - PushService - There was a failure while pushing data to store:001:001. 1 data and 1 batches were processed
[replonv2] - PushService - Push data sent to store:001:001
[azure] - IncomingBatchService - Retrying batch 000-13
[azure] - DataLoaderService - Failed while parsing batch
java.lang.IllegalStateException: There are no keys defined for Reporting-DB.dbo.booking_offers. Cannot build an update statement. The only keys defined are binary and they have been removed.
    at org.jumpmind.symmetric.io.data.writer.DefaultDatabaseWriter.update(DefaultDatabaseWriter.java:423)
    at org.jumpmind.symmetric.io.data.writer.AbstractDatabaseWriter.write(AbstractDatabaseWriter.java:152)
    at org.jumpmind.symmetric.io.data.writer.NestedDataWriter.write(NestedDataWriter.java:64)
    at org.jumpmind.symmetric.model.ProcessInfoDataWriter.write(ProcessInfoDataWriter.java:65)
    at org.jumpmind.symmetric.io.data.writer.NestedDataWriter.write(NestedDataWriter.java:64)
    at org.jumpmind.symmetric.io.data.writer.TransformWriter.write(TransformWriter.java:204)
    at org.jumpmind.symmetric.io.data.DataProcessor.forEachDataInTable(DataProcessor.java:200)
    at org.jumpmind.symmetric.io.data.DataProcessor.forEachTableInBatch(DataProcessor.java:170)
    at org.jumpmind.symmetric.io.data.DataProcessor.process(DataProcessor.java:116)
    at org.jumpmind.symmetric.service.impl.DataLoaderService$LoadIntoDatabaseOnArrivalListener.end(DataLoaderService.java:855)
    at org.jumpmind.symmetric.io.data.writer.StagingDataWriter.notifyEndBatch(StagingDataWriter.java:75)
    at org.jumpmind.symmetric.io.data.writer.AbstractProtocolDataWriter.end(AbstractProtocolDataWriter.java:220)
    at org.jumpmind.symmetric.io.data.DataProcessor.process(DataProcessor.java:130)
    at org.jumpmind.symmetric.service.impl.DataLoaderService.loadDataFromTransport(DataLoaderService.java:463)
    at org.jumpmind.symmetric.service.impl.DataLoaderService.loadDataFromPush(DataLoaderService.java:350)
    at org.jumpmind.symmetric.web.PushUriHandler.push(PushUriHandler.java:77)
    at org.jumpmind.symmetric.web.PushUriHandler.handle(PushUriHandler.java:66)
    at org.jumpmind.symmetric.web.SymmetricServlet.service(SymmetricServlet.java:103)
    at javax.servlet.http.HttpServlet.service(HttpServlet.java:790)
    at org.eclipse.jetty.servlet.ServletHolder.handle(ServletHolder.java:808)
    at org.eclipse.jetty.servlet.ServletHandler.doHandle(ServletHandler.java:587)
    at org.eclipse.jetty.server.handler.ScopedHandler.handle(ScopedHandler.java:143)
    at org.eclipse.jetty.security.SecurityHandler.handle(SecurityHandler.java:577)
    at org.eclipse.jetty.server.session.SessionHandler.doHandle(SessionHandler.java:223)
    at org.eclipse.jetty.server.handler.ContextHandler.doHandle(ContextHandler.java:1127)
    at org.eclipse.jetty.servlet.ServletHandler.doScope(ServletHandler.java:515)
    at org.eclipse.jetty.server.session.SessionHandler.doScope(SessionHandler.java:185)
    at org.eclipse.jetty.server.handler.ContextHandler.doScope(ContextHandler.java:1061)
    at org.eclipse.jetty.server.handler.ScopedHandler.handle(ScopedHandler.java:141)
    at org.eclipse.jetty.server.handler.HandlerWrapper.handle(HandlerWrapper.java:97)
    at org.eclipse.jetty.server.Server.handle(Server.java:499)
    at org.eclipse.jetty.server.HttpChannel.handle(HttpChannel.java:310)
    at org.eclipse.jetty.server.HttpConnection.onFillable(HttpConnection.java:257)
    at org.eclipse.jetty.io.AbstractConnection$2.run(AbstractConnection.java:540)
    at org.eclipse.jetty.util.thread.QueuedThreadPool.runJob(QueuedThreadPool.java:635)
    at org.eclipse.jetty.util.thread.QueuedThreadPool$3.run(QueuedThreadPool.java:555)
    at java.lang.Thread.run(Thread.java:745)


Additional InformationSource is MySQL 5.6.25 and that data should flow unidirectionally to SQL Azure.
Tagsdata type, dialect: mysql/mariadb

Relationships

related to 0000963 closedjosh-a-hicks Update and delete does not sync on tables with varbinary primary key 

Activities

MikaN

2016-04-22 01:40

reporter   ~0000786

Anyone? This issues makes SymmetricDS practically useless because after the initial sync SymmetricDS is crashing because of that error.

Related Changesets

SymmetricDS: 3.10 28fd261d

2019-05-14 16:25:02

josh-a-hicks

Details Diff
0002563: When Primary key is binary; SymmetricDS fails capture changes.
0002563
mod - symmetric-jdbc/src/main/java/org/jumpmind/db/platform/mysql/MySqlDatabasePlatform.java Diff File

Issue History

Date Modified Username Field Change
2016-04-14 08:25 MikaN New Issue
2016-04-22 01:40 MikaN Note Added: 0000786
2019-04-24 08:39 elong Tag Attached: dialect: mysql/mariadb
2019-04-24 08:39 elong Tag Attached: data type
2019-05-14 08:32 elong Relationship added related to 0000963
2019-05-14 16:32 josh-a-hicks Assigned To => josh-a-hicks
2019-05-14 16:32 josh-a-hicks Status new => resolved
2019-05-14 16:32 josh-a-hicks Resolution open => fixed
2019-05-14 16:32 josh-a-hicks Fixed in Version => 3.10.3
2019-05-14 17:00 josh-a-hicks Changeset attached => SymmetricDS 3.10 28fd261d
2019-06-25 14:06 admin Status resolved => closed